#ifndef _EWMH_H_
#define _EWMH_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/Xresource.h>
#include <X11/Xmd.h>
#include <X11/keysym.h>
#include <X11/cursorfont.h>

#include "structs.h"
#include "wm.h"

#define WINDOW_TYPE_TOOLBAR 0
#define WINDOW_TYPE_DOCK    1
#define WINDOW_TYPE_DIALOG  2
#define WINDOW_TYPE_SPLASH 21

#define MB_DOCK_ALIGN 3
#define MB_DOCK_ALIGN_EAST 4
#define MB_DOCK_ALIGN_WEST 5
#define MB_COMMAND 22

#define WINDOW_TYPE_DESKTOP 6

#define WINDOW_STATE             7
#define WINDOW_STATE_FULLSCREEN  8

#define _NET_SUPPORTED           9
#define _NET_CLIENT_LIST         10
#define _NET_NUMBER_OF_DESKTOPS  11
#define _NET_ACTIVE_WINDOW       12
#define _NET_SUPPORTING_WM_CHECK 13

#define _NET_CLOSE_WINDOW        14

#define _NET_WM_NAME             15
#define UTF8_STRING              16
#define _NET_CLIENT_LIST_STACKING 17
#define _NET_CURRENT_DESKTOP 18

#define _NET_DESKTOP_GEOMETRY 19
#define _NET_WORKAREA         20

/* Non aton defines */
#define _NET_WM_STATE_REMOVE        0    /* remove/unset property */
#define _NET_WM_STATE_ADD           1    /* add/set property */
#define _NET_WM_STATE_TOGGLE        2    /* toggle property  */

void ewmh_init(Wm *w);
void ewmh_update(Wm *w);
void ewmh_set_active(Wm *w);
int  ewhm_handle_root_message(Wm *w, XClientMessageEvent *e);
unsigned char *ewmh_get_utf8_name(Wm *w, Window win);

#endif
