/* matchbox - a lightweight window manager

   Copyright 2002 Matthew Allum

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#ifndef _MBTHEME_H_
#define _MBTHEME_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/Xresource.h>
#include <X11/Xmd.h>
#include <X11/keysym.h>
#include <X11/cursorfont.h>
#include <X11/xpm.h>

#ifdef USE_XFT
#include <X11/Xft/Xft.h>
#endif

#include "structs.h"
#include "xml.h"
#include "wm.h"


#define GET_INT_ATTR(n,k,v) \
    if (get_attr((n), (k))) (v) = atoi(get_attr((n), (k))); else return 0; 

int  theme_get_text_length(MBtheme *t, Tfont *font, char *str, int cnt);
int mbtheme_is_button(/* frame ref */ int x, int y);			
void mbtheme_button_activate(/* button ref */);
void mbtheme_button_deactivate(/* button ref */);
int gparam_convert( Tframe *t, Gparam *g, int orientation);
int theme_get_frame_size( MBtheme *t, int frame_ref );
void theme_scale_pixmap(MBtheme *t, Pixmap p_in, Pixmap m_in,
			Pixmap p_ret, Pixmap m_ret );
void theme_pixmap_paint(MBtheme *t, Client *c, Tpixmap *p,
			int x, int y, int w, int h);
void theme_paint( MBtheme *t, Client *c, int frame_ref );
void theme_paint_button(MBtheme *t, Client *c, int action,
			int state, int frame_ref );
Gparam *gparam_new(char *def_str);
Tlayer *tlayer_new();
Tcolor *tcolor_new(MBtheme *t, char *defstr, char *name);

Tfont *tfont_new(MBtheme *t, char *defstr, char *name);
Tfont *tfont_lookup(MBtheme *theme, char *name);

Tpixmap *tpixmap_new(MBtheme *t, char *filename, char *name);
Tpixmap *tpixmap_lookup(MBtheme *theme, char *name);
Tpixmap *tpicture_new(MBtheme *t, int w, int h, Tcolor *tcol, char *name);
Tpixmap *tpicture_lookup(MBtheme *theme, char *name);
Tlabel *tlabel_new(MBtheme *t, Tfont *font,
		   Tcolor *col , Tcolor *bgcol, char *justify);
Tbutton *tbutton_new(MBtheme *t);
MBtheme* mbtheme_new(Wm *w);
Tframe *theme_get_frame(MBtheme *t, int req_id);
void mbtheme_switch(Wm *w, char *new_theme_conf);
void mbtheme_init(Wm *w, char *theme_conf);
#endif
