#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/stat.h>
 
typedef struct _params {
   char *key;
   char *value;
   struct _params *next;
} Params;

typedef struct _nlist {
   struct _xml_node *data;
   struct _nlist *next;
} Nlist;

typedef struct _xml_node {

   char *tag;
   Params *attr;
   char *cdata;
   
   struct _xml_node *parent; 
   Nlist *kids;

} XMLNode;

typedef struct _xmlparser {
   void (* start_element_cb)( struct _xmlparser  *parser,
			      char *tag, Params *attr);
   void (* end_element_cb)( struct  _xmlparser *parser, char *tag );
   void (* data_cb)( struct  _xmlparser *parser, char *data );
   XMLNode *root_node;
   XMLNode *_current_node;
} XMLParser;

Nlist *list_add_node(XMLNode *dest, XMLNode *new);

XMLNode *new_xmlnode(char *name, Params *attr);

void xml_dump(XMLNode *node, int depth);


/* --------------------------------------------------------------- */

Params *new_params(void);

XMLParser *new_xmlparser(void);

XMLNode *parse_data_dom(XMLParser *parser, char *data);

XMLNode *parse_file_dom(XMLParser *parser, char *filename);

void free_xmlparser(XMLParser *parser, XMLNode *root);
